<template>
    <div class="App"/>
</template>

<script>
    import gmapsInit from '~/utils/gmaps';
    import $ from 'jquery';

    export default {
        name: 'App',
        props: [
            "location",
        ],
        data() {
            return {
                google: {},
                map: {},
                center: {
                    lat: 0,
                    lng: 0
                },
            }
        },
        async mounted() {
            try {
                var that = this;
                that.google = await gmapsInit();
                const geocoder = new google.maps.Geocoder();
                that.map = new that.google.maps.Map(that.$el);

                this.map.setCenter(that.center);

                that.google.maps.event.addListener( that.map, 'bounds_changed', function() {that.onBoundsChanged(that.map)} );
            } catch (error) {
                console.error(error);
            }
        },
        methods: {
            onBoundsChanged(map) {
                if ( Math.round($(map.getDiv()).children().eq(0).height()) == Math.round(window.innerHeight) &&
                    Math.round($(map.getDiv()).children().eq(0).width())  == Math.round(window.innerWidth )) {
                    map.setOptions({draggable: true});
                }
                else {
                    map.setOptions({draggable: false});
                }

            }
        },
        watch: {
            location: function () {
                if(this.map == null) return;
                if(this.location && this.location.lat != null && this.location.lng != null){

                    this.map.setZoom(17);
                    this.map.setCenter(this.location);

                    var marker = new this.google.maps.Marker({
                        position: this.location,
                        map: this.map,
                    });
                }else{
                    this.map.setZoom(17);
                    this.map.setCenter(this.center);
                }
            }
        }
    };
</script>

<style>
    .App {
        width: 100%;
        height: 145px;
        border: 1px solid #eeeeee;
    }
</style>